# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/pinctrl/amlogic,meson-pinctrl-g12a-aobus.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Amlogic Meson G12 AOBUS pinmux controller

maintainers:
  - Neil Armstrong <neil.armstrong@linaro.org>

allOf:
  - $ref: amlogic,meson-pinctrl-common.yaml#

properties:
  compatible:
    enum:
      - amlogic,meson-g12a-aobus-pinctrl

required:
  - compatible

patternProperties:
  "^bank@[0-9a-z]+$":
    $ref: amlogic,meson-pinctrl-common.yaml#/$defs/meson-gpio

    unevaluatedProperties: false

    properties:
      reg:
        maxItems: 3

      reg-names:
        items:
          - const: mux
          - const: ds
          - const: gpio

      gpio-line-names:
        maxItems: 15

unevaluatedProperties:
  type: object
  $ref: amlogic,meson-pinctrl-common.yaml#/$defs/meson-pins

examples:
  - |
    ao_pinctrl: pinctrl {
      compatible = "amlogic,meson-g12a-aobus-pinctrl";
      #address-cells = <1>;
      #size-cells = <1>;
      ranges;

      bank@14 {
        reg = <0x14 0x8>,
              <0x1c 0x8>,
              <0x24 0x14>;
        reg-names = "mux", "ds", "gpio";
        gpio-controller;
        #gpio-cells = <2>;
        gpio-ranges = <&ao_pinctrl 0 0 15>;
      };

      cec_ao_a_h_pins: cec_ao_a_h {
        mux {
          groups = "cec_ao_a_h";
          function = "cec_ao_a_h";
          bias-disable;
        };
      };
    };
